<script setup lang="ts">
import Layout from "@/components/Layout.vue";
import Pagination from "@/components/Pagination.vue";
import Sidebar from "@/components/Sidebar.vue";
import BirdhouseOverview from "./components/BirdhouseOverview/BirdhouseOverview.vue";
import BirdhouseGraph from "./components/BirdhouseGraph/BirdhouseGraph.vue";
import BirdhouseTab from "./components/BirdhouseTab/BirdhouseTab.vue";
import { computed, onMounted, ref, watch } from "vue";
import { GetBirdhouseInfoResponse, GetGraphResidencyDataResponse, GetResidencyDataResponse } from "./types/response";
import { axios } from "@/libs/axios";
import { useRoute } from "vue-router";
import { useToast } from "vue-toast-notification";
import {
  GET_BIRDHOUSE_INFO_ENDPOINT,
  GET_GRAPH_RESIDENCY_DATA_ENDPOINT,
  GET_RESIDENCY_DATA_ENDPOINT
} from "@/views/BirdhouseView/constants/apiEndpoints";
import { RESIDENCY_DATA_PER_PAGE } from "@/views/BirdhouseView/constants/paginationConfig";
import { BirdhouseInfo, ResidencyData } from "@/views/BirdhouseView/types/models";
import { BirdHouseGraphProps } from "@/views/BirdhouseView/components/BirdhouseGraph/types/birdHouseGraphProps";

const route = useRoute();

const tabs = ['overview', 'graph']
let activeTab = ref(tabs[0]);
const tabDataCache = {
  [tabs[0]]: null,
  [tabs[1]]: null,
};

const birdhouseInfo = ref<BirdhouseInfo>({
  name: '',
  latitude: 0,
  longitude: 0
});
const residencyData = ref<ResidencyData[]>([]);
const graphResidencyData = ref<BirdHouseGraphProps[]>([]);

const totalItems = ref(0);
const currentPage = computed(() => {
  return route.query.page ?? 1
});

const $toast = useToast()
const id = route.params.id;

const fetchBirdhouseData = async () => {
  try {
    const response: GetBirdhouseInfoResponse = await axios.get(GET_BIRDHOUSE_INFO_ENDPOINT.replace(":id", id as string), {
      headers: {
        'Content-Type': 'application/json',
        accept: 'application/json',
        'X-UBID': id
      }
    });

    birdhouseInfo.value = {
      ...response
    };
  } catch (error) {
    $toast.error('Error fetching birdhouse:', error)
  }
}

const fetchResidencyData = async () => {
  try {
    const response: GetResidencyDataResponse = await axios.get(GET_RESIDENCY_DATA_ENDPOINT.replace(':id', id as string), {
      params: {
        limit: RESIDENCY_DATA_PER_PAGE,
        page: currentPage.value
      },
      headers: {
        'Content-Type': 'application/json',
        accept: 'application/json',
        'X-UBID': id
      }
    });

    residencyData.value = response.data;
    totalItems.value = response.total;
  } catch (error) {
    $toast.error('Error fetching residency data:', error)
  }
};

const fetchGraphResidencyData = async () => {
  if (tabDataCache[activeTab]) {
    graphResidencyData.value = tabDataCache[activeTab]
    return;
  }

  try {
    const response: GetGraphResidencyDataResponse = await axios.get(GET_GRAPH_RESIDENCY_DATA_ENDPOINT.replace(':id', id as string), {
      headers: {
        'Content-Type': 'application/json',
        accept: 'application/json',
        'X-UBID': id
      }
    });

    graphResidencyData.value = transformGraphResidencyData(response)
    tabDataCache[activeTab] = graphResidencyData.value
  } catch (error) {
    $toast.error('Error fetching residency data for graph:', error)
  }
};

const transformGraphResidencyData = (apiResponse: GetGraphResidencyDataResponse): BirdHouseGraphProps[] => {
  return apiResponse.reduce((result, entry) => {
    // Loop through the keys "eggs" and "birds"
    [ "eggs", "birds" ].forEach((key) => {
      // Find or create an entry in the result array with the name as the key ("eggs" or "birds")
      let dataEntry = result.find((item) => item.name === key);
      if (!dataEntry) {
        dataEntry = { name: key, data: [] };
        result.push(dataEntry);
      }

      // Extract the numeric value for the current key ("eggs" or "birds") and push it to the data array
      dataEntry.data.push(entry[key]);
    });

    return result;
  }, []);
};

onMounted(() => {
  fetchBirdhouseData();
  fetchResidencyData();
});

watch(
    () => route.query.page,
    () => {
      fetchResidencyData();
    }
);

watch(
    () => activeTab.value,
    () => {
      fetchGraphResidencyData();
    }
);

const setActiveTab = (tab: string) => {
  activeTab.value = tab;
};
</script>

<template>
  <Layout>
    <div class="flex">
      <!-- Sidebar -->
      <Sidebar/>

      <!-- Content -->
      <div class="flex-1 bg-very-dark-gray h-[84vh]">
        <div class="m-8 bg-dark-charcoal-gray rounded-xl">
          <div class="pt-6 pl-6 pr-6 pb-5 flex justify-between items-center">
            <h2 class="text-white text-2xl font-poppins font-semibold">{{ birdhouseInfo.name }}</h2>
            <div class="flex">
              <img src="@/assets/icons/location.svg" alt="Location" class="mr-3"/>
              <span class="text-white text-base font-medium">({{ birdhouseInfo.longitude }}, {{  birdhouseInfo.latitude }})</span>
            </div>
          </div>

          <!-- Tabs -->
          <div class="flex items-center pl-6 pb-3 text-white text-base font-normal font-poppins">
            <!-- Overview Tab -->
            <BirdhouseTab
                :tabName="tabs[0]"
                :activeTab="activeTab"
                :setActiveTab="setActiveTab"
                :tabText="'Overview'"
                custom-classes="mr-8"
            />

            <!-- Graph Tab -->
            <BirdhouseTab
                :tabName="tabs[1]"
                :activeTab="activeTab"
                :setActiveTab="setActiveTab"
                :tabText="'Graph'"
            />
          </div>
        </div>

        <!-- Conditional rendering based on activeTab -->
        <div v-if="activeTab === tabs[0]">
          <BirdhouseOverview
            :residency-data="residencyData"
          />
        </div>
        <div v-else-if="activeTab === tabs[1]">
          <BirdhouseGraph
            :graph-residency-data="graphResidencyData"
          />
        </div>
      </div>
      </div>

    <div class="flex justify-center items-center p-4">
      <Pagination
          :totalItems="totalItems"
          :itemsPerPage="RESIDENCY_DATA_PER_PAGE"
      />
    </div>
  </Layout>
</template>

<style scoped>
.active-tab {
  color: #5051F9;
  opacity: 1;
  position: relative;
}

.active-tab:after {
  position: absolute;
  content: '';
  border-bottom: 2px solid #5051F9;
  width: 100%;
  transform: translateX(-50%);
  bottom: -12px;
  left: 50%;
}
</style>
